#pragma symbols code debug objectextend optimize(4)
#include <reg51.h>
#include <stdio.h>
// robotsmall.c
//commandes L298
sbit inGplus=P1^0; sbit inGmoins=P1^1;
sbit inDplus=P1^4; sbit inDmoins=P1^5;
sbit enMotG=P1^2; sbit enMotD=P1^3;
//Port P3
sbit Led1=P3^1;
sbit Led2=P3^0;
sbit Buz=P3^2;
sbit US=P1^7;
sbit TP1=P3^3;
sbit TP2=P3^4;
sbit TP3=P3^5;
sbit TP4=P1^6;

//variables
unsigned char mem;
unsigned char memTH0;
unsigned char memTL0;
unsigned char Flag;					
unsigned long j;

// Procdures d'interruptions
void Tempo (void);		//timer 0  

//Prog principal

void main (void)
{
	inDplus = 0; inDmoins = 0;	// moteurs arret
 	inGplus = 0; inGmoins = 0; 
 	enMotG = 1; enMotD = 1;
 	TMOD = 0x11;					// Timer mode 1 hrl interne	
 	TH0 = 0x6F;					 	// timer 0   20ms
 	TL0 = 0xDA;
 	memTH0 = TH0;
   memTL0 = TL0;
 	ET0=1;EA=1;
 	Flag=0;P3=0xFF;
 	mem=60;
 	if (TP1==0) mem=30;			// choix tempo de rotation
 	if (TP2==0) mem=50;
 	if (TP3==0) mem=70;
 	Led2 = 0;
 	j = 0;
 	TR0=1;
	do
	{
		Flag=(!Flag) & 1;
		if (US == 1)
		{
			inDplus = 1; inDmoins = 0;	// moteurs marche
 			inGplus = 1; inGmoins = 0; 
 			Led1 = 1;
 			Buz = 1;
 		}
 		else
 		{
 			j=0;Led1 = 0;
 			while (j<=30)
 				{
 					inDplus = 0; inDmoins = 1;	// marche arriere
 					inGplus = 0; inGmoins = 1;
 					if (TP4==0) Buz = 0;
 				}
 			if (Flag==0)
 			{
 				j=0;
 				while (j<=mem)
 				{
 					inDplus = 1; inDmoins = 0;	// Rotation
 					inGplus = 0; inGmoins = 1;
 					Buz = 1;
 				}
	 		}
	 		else
	 		{
	 			j=0;
	 			while (j<=mem)
 				{
 					inDplus = 0; inDmoins = 1;	// Rotation inverse
 					inGplus = 1; inGmoins = 0;
 					Buz = 1;
 				}
 			}
	 	}
	}
	while(1);
}

void Tempo (void) interrupt 1	//Tempo 20ms
{
 TH0 = memTH0;
 TL0 = memTL0;
 j = j+1;
}






